"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ButtonDropdown = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Button = require("./../Button");

var _Button2 = _interopRequireDefault(_Button);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Transition = require("react-transition-group/Transition");

var _Transition2 = _interopRequireDefault(_Transition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonDropdown = exports.ButtonDropdown = function (_Component) {
	_inherits(ButtonDropdown, _Component);

	function ButtonDropdown(props) {
		_classCallCheck(this, ButtonDropdown);

		var _this = _possibleConstructorReturn(this, (ButtonDropdown.__proto__ || Object.getPrototypeOf(ButtonDropdown)).call(this, props));

		_this.toggleOpen = function () {
			_this.setState({ isOpen: !_this.state.isOpen });
		};

		_this.handleClick = function (event) {
			if (_this.state.isOpen || event.target.classList.contains("cp-DropdownMenu") && event.target.classList.contains(_this.props.className)) {
				_this.setState({ isOpen: !_this.state.isOpen });
			}
		};

		_this.primaryAction = function () {
			return _this.props.children[0];
		};

		_this.secondaryActions = function () {
			return _this.props.children.slice(1);
		};

		_this.render = function () {
			var id = _this.props.id;
			var isOpen = _this.state.isOpen.isOpen;

			var transitionProps = {
				in: _this.state.isOpen,
				timeout: _this.props.transitionTimeout
			};

			return _react2.default.createElement(
				"div",
				{
					className: "cp-dropdownButton cp-clearfix " + (_this.props.slim ? "cp-dropdownButton--slim" : "")
				},
				_react2.default.createElement(
					_Button2.default,
					_extends({
						type: "primary",
						className: "cp-Btn--withDropdown"
					}, _this.primaryAction().props),
					_this.primaryAction().props.children
				),
				_react2.default.createElement(
					"div",
					{
						id: id,
						tabIndex: "0",
						className: _this.props.className + " cp-DropdownMenu " + (isOpen ? "is-open" : "") + " " + (_this.props.size === "small" ? "cp-DropdownMenu--small" : ""),
						disabled: _this.props.disabled != null ? _this.props.disabled : false
					},
					_react2.default.createElement(
						"svg",
						{ className: "cp-DropdownMenu-arrow--down" },
						_react2.default.createElement("use", { xlinkHref: "#iconArrow--down" })
					),
					_react2.default.createElement(
						_Transition2.default,
						transitionProps,
						function (state) {
							return _react2.default.createElement(
								"div",
								{
									className: "cp-DropdownMenu-menu Dropdown-fade-" + state
								},
								_this.secondaryActions()
							);
						}
					)
				)
			);
		};

		_this.state = {
			isOpen: false,
			selectedOption: ""
		};
		return _this;
	}

	_createClass(ButtonDropdown, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			document.addEventListener("mousedown", this.handleClick);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			document.removeEventListener("mousedown", this.handleClick);
		}
	}]);

	return ButtonDropdown;
}(_react.Component);

ButtonDropdown.propTypes = {
	className: _propTypes2.default.string,
	id: _propTypes2.default.string.isRequired,
	onChange: _propTypes2.default.func,
	size: _propTypes2.default.oneOf(["small"]),
	slim: _propTypes2.default.bool,
	options: _propTypes2.default.array,
	transitionTimeout: _propTypes2.default.oneOfType([_propTypes2.default.shape({
		enter: _propTypes2.default.number,
		exit: _propTypes2.default.number
	}), _propTypes2.default.number])
};
ButtonDropdown.defaultProps = {
	startValue: "Select an option",
	transitionTimeout: 240,
	onChange: function onChange(e) {}
};
exports.default = ButtonDropdown;