'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _jestMatchers = require('jest-matchers');

var _jestMatchers2 = _interopRequireDefault(_jestMatchers);

var _CPCard = require('./CPCard');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var dataForCards = [{
	title: 'This is the title.',
	description: 'this is a description',
	date: '2017-09-08T17:48:57Z',
	contentType: 'event'
}];

function dateFormat(date) {
	var formattedDate = new _moment2.default(date);
	return formattedDate.format('MMM') + ' ' + formattedDate.date() + ', ' + formattedDate.year() + ' ' + formattedDate.format('h:mm A');
}

it('Expects the rendered card list to have fields with text equal to what was passed in.', function () {
	var data = dataForCards[0];
	var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_CPCard.CPCard, {
		data: data
	}));

	var title = wrapper.find('.cp-card-title');
	(0, _jestMatchers2.default)(title.text()).toBe(data.title);

	var description = wrapper.find('.cp-card-description');
	(0, _jestMatchers2.default)(description.text()).toBe(data.description);

	var date = wrapper.find('.cp-card-metaItem--date');
	(0, _jestMatchers2.default)(date.text()).toBe(dateFormat(data.date));

	var contentType = wrapper.find('.cp-card-metaItem--contentType');
	(0, _jestMatchers2.default)(contentType.text()).toBe(data.contentType);
});