'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.CPHeader = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SearchBar = require('./../SearchBar');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CPHeader = exports.CPHeader = function (_Component) {
	_inherits(CPHeader, _Component);

	function CPHeader() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, CPHeader);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CPHeader.__proto__ || Object.getPrototypeOf(CPHeader)).call.apply(_ref, [this].concat(args))), _this), _this.render = function () {
			var title = _this.props.title;
			var titleLink = _this.props.titleLink;
			var subtitle = _this.props.subtitle;
			var subtitleLink = _this.props.subtitleLink;
			var icon = _this.props.icon;

			// defaults
			var logoLinkMarkup = _react2.default.createElement(
				'span',
				{ className: 'cp-Header-logo' },
				_react2.default.createElement(
					'svg',
					null,
					_react2.default.createElement('use', { xlinkHref: '#' + icon }),
					' '
				)
			);

			var titleLinkMarkup = title;
			var subtitleLinkMarkup = subtitle;
			var rightContentMarkup = '';

			if (titleLink !== undefined) {
				logoLinkMarkup = _react2.default.createElement(
					'a',
					{ href: titleLink, className: 'cp-Header-logo' },
					_react2.default.createElement(
						'svg',
						null,
						_react2.default.createElement('use', { xlinkHref: '#' + icon })
					)
				);

				titleLinkMarkup = _react2.default.createElement(
					'a',
					{ href: titleLink },
					title
				);
			}

			if (subtitleLink !== undefined) {
				subtitleLinkMarkup = _react2.default.createElement(
					'a',
					{ href: subtitleLink, className: 'cp-ViewSite' },
					subtitle
				);
			}

			if (_this.props.displaySearch) {
				rightContentMarkup = _react2.default.createElement(_SearchBar.SearchBar, {
					isModuleSearch: true,
					placeholder: _this.props.searchPlaceHolder || "Search",
					onKeyPressHandler: _this.props.searchInputHandler,
					onClickHandler: _this.props.searchFunction,
					isSubmitSearch: _this.props.isSubmitSearch,
					clearSearchFunction: _this.props.clearSearchFunction
				});
			} else if (_this.props.contentRight) {
				rightContentMarkup = _this.props.contentRight;
			}

			return _react2.default.createElement(
				'div',
				{ className: 'cp-Header' },
				_react2.default.createElement(
					'div',
					{ className: 'cp-LayoutWrap cp-LayoutWrap--noLeftNav cp-Header-inner' },
					_react2.default.createElement(
						'div',
						{ className: 'cp-Header-left' },
						_react2.default.createElement(
							'div',
							{ className: 'cp-Header-title' },
							logoLinkMarkup,
							_react2.default.createElement(
								'h1',
								null,
								titleLinkMarkup,
								_react2.default.createElement(
									'small',
									null,
									subtitleLinkMarkup
								)
							)
						)
					),
					rightContentMarkup ? _react2.default.createElement(
						'div',
						{ className: 'cp-Header-right' },
						rightContentMarkup
					) : ''
				)
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return CPHeader;
}(_react.Component);

CPHeader.propTypes = {
	/** Something */
	title: _propTypes2.default.string,
	titleLink: _propTypes2.default.string,
	subtitle: _propTypes2.default.string,
	subtitleLink: _propTypes2.default.string,
	icon: _propTypes2.default.string,
	displaySearch: _propTypes2.default.bool,
	searchFunction: _propTypes2.default.func,
	searchInputHandler: _propTypes2.default.func,
	searchPlaceHolder: _propTypes2.default.string,
	isSubmitSearch: _propTypes2.default.bool,
	clearSearchFunction: _propTypes2.default.func,
	contentRight: _propTypes2.default.node
};
CPHeader.defaultProps = {
	title: 'Feature Name',
	subtitle: 'Organization',
	icon: 'iconModules',
	displaySearch: true,
	contentRight: ''
};
exports.default = CPHeader;