"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.CPTitleBar = undefined;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require("react-router-dom");

var _CPLayoutWrap = require("./../CPLayoutWrap");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CPTitleBar = exports.CPTitleBar = function (_Component) {
	_inherits(CPTitleBar, _Component);

	function CPTitleBar() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, CPTitleBar);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CPTitleBar.__proto__ || Object.getPrototypeOf(CPTitleBar)).call.apply(_ref, [this].concat(args))), _this), _this.render = function () {
			var breadcrumbs = _this.props.breadcrumbs;

			var breadcrumbMarkup = void 0;

			if (breadcrumbs) {
				var listItems = breadcrumbs.map(function (d, index) {
					return _react2.default.createElement(
						"span",
						{ key: index },
						d.linkTo ? _react2.default.createElement(
							_reactRouterDom.Link,
							{
								to: d.linkTo,
								className: "cp-ModuleBreadcrumbs-crumbLink"
							},
							d.text
						) : _react2.default.createElement(
							"a",
							{
								href: d.url,
								className: "cp-ModuleBreadcrumbs-crumbLink"
							},
							d.text
						),
						_react2.default.createElement(
							"span",
							{ className: "cp-ModuleBreadcrumbs-separator" },
							_react2.default.createElement(
								"svg",
								null,
								_react2.default.createElement("use", { xlinkHref: "#iconArrow--right" })
							)
						)
					);
				});
				breadcrumbMarkup = _react2.default.createElement(
					"div",
					{ className: "cp-ModuleBreadcrumbs" },
					listItems,
					_react2.default.createElement(
						"span",
						{ className: "cp-ModuleBreadcrumbs-crumb" },
						_react2.default.createElement(
							"span",
							{ className: "cp-ModuleBreadcrumbs-crumbText" },
							_this.props.title
						)
					)
				);
			} else {
				breadcrumbMarkup = _react2.default.createElement(
					"div",
					{ className: "cp-ModuleBreadcrumbs" },
					_react2.default.createElement(
						"span",
						{ className: "cp-ModuleBreadcrumbs-crumb" },
						_react2.default.createElement(
							"span",
							{ className: "cp-ModuleBreadcrumbs-crumbText" },
							_this.props.title
						)
					)
				);
			}

			return _react2.default.createElement(
				"div",
				{ id: "cp-TitleBar", className: "cp-TitleBar" },
				_react2.default.createElement(
					_CPLayoutWrap.CPLayoutWrap,
					null,
					_react2.default.createElement(
						"div",
						{ className: "cp-TitleBar-inner" },
						_react2.default.createElement(
							"div",
							{ className: "cp-TitleBar-content" },
							breadcrumbMarkup
						),
						_react2.default.createElement(
							"div",
							{ className: "cp-BtnGroup cp-TitleBar-buttons" },
							_this.props.children
						)
					)
				)
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return CPTitleBar;
}(_react.Component);

CPTitleBar.propTypes = {
	/** Something */
	title: _propTypes2.default.string,
	breadcrumbs: _propTypes2.default.array
};
exports.default = CPTitleBar;