"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ColorPicker = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Transition = require("react-transition-group/Transition");

var _Transition2 = _interopRequireDefault(_Transition);

var _reactColor = require("react-color");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ColorPicker = exports.ColorPicker = function (_Component) {
	_inherits(ColorPicker, _Component);

	function ColorPicker(props) {
		_classCallCheck(this, ColorPicker);

		var _this = _possibleConstructorReturn(this, (ColorPicker.__proto__ || Object.getPrototypeOf(ColorPicker)).call(this, props));

		_this.handleOpen = function () {
			_this.setState({ isOpen: !_this.state.isOpen });
		};

		_this.handleClose = function (e) {
			if (e.target === _this.wrapperRef) {
				_this.setState({ isOpen: false });
			}
		};

		_this.render = function () {
			var id = _this.props.id;
			var isOpen = _this.state.isOpen;

			var color = _this.props.color;
			var normalizedColor = color != null && (typeof color === "undefined" ? "undefined" : _typeof(color)) === "object" ? "rgba(" + color.r + ", " + color.g + ", " + color.b + ", " + color.a + ")" : color;
			return _react2.default.createElement(
				"div",
				{ id: id, ref: _this.setWrapperRef, className: "cp-colorSwatch cp-clearfix " + (isOpen ? "has-menuOpen" : ""), onClick: _this.handleClose },
				_react2.default.createElement(
					"button",
					{ className: "cp-colorSwatch-button " + (isOpen ? "is-open" : ""), onClick: _this.handleOpen },
					_react2.default.createElement("div", {
						className: "cp-colorSwatch-color " + (normalizedColor ? "" : "cp-colorSwatch-color--empty"),
						style: { backgroundColor: normalizedColor }
					}),
					_react2.default.createElement(
						"svg",
						{ className: "cp-colorSwatch-arrow cp-colorSwatch-arrow--down" },
						_react2.default.createElement("use", { xlinkHref: "#iconArrow--down" })
					)
				),
				normalizedColor && _react2.default.createElement(
					"button",
					{
						className: "cp-colorSwatch-clear",
						onClick: function onClick(e) {
							return _this.onChangeHandler(null, e);
						}
					},
					_react2.default.createElement(
						"svg",
						null,
						_react2.default.createElement("use", { xlinkHref: "#iconClose" })
					)
				),
				_this.renderMenu()
			);
		};

		_this.onChangeHandler = function (color, e) {
			var shouldCloseColorPicker = _this.props.onChange && _this.props.onChange(color, e);
			if (shouldCloseColorPicker) {
				_this.setState({ isOpen: false });
			}
		};

		_this.renderMenu = function () {
			var transitionTimeout = _this.props.transitionTimeout;
			var isOpen = _this.state.isOpen;

			var transitionProps = { in: isOpen, timeout: transitionTimeout };
			return _react2.default.createElement(
				_Transition2.default,
				transitionProps,
				function (state) {
					return _react2.default.createElement(
						"div",
						{ className: "cp-colorSwatch-selector cp-colorSwatch-selector-fade-" + state },
						_react2.default.createElement(_reactColor.SketchPicker, {
							presetColors: Array.from(new Set(_this.props.presetColors)),
							color: _this.props.color,
							onChange: _this.onChangeHandler,
							onChangeComplete: _this.props.onChangeComplete
						})
					);
				}
			);
		};

		_this.state = {
			isOpen: false
		};

		_this.setWrapperRef = _this.setWrapperRef.bind(_this);
		_this.handleClickOutside = _this.handleClickOutside.bind(_this);
		_this.handleTabOutside = _this.handleTabOutside.bind(_this);
		_this.onChangeHandler = _this.onChangeHandler.bind(_this);
		_this.handleOpen = _this.handleOpen.bind(_this);
		_this.handleClose = _this.handleClose.bind(_this);
		return _this;
	}

	_createClass(ColorPicker, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			document.addEventListener("mousedown", this.handleClickOutside);
			document.addEventListener("keyup", this.handleTabOutside);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			document.removeEventListener("mousedown", this.handleClickOutside);
			document.removeEventListener("keyup", this.handleTabOutside);
		}
	}, {
		key: "setWrapperRef",
		value: function setWrapperRef(node) {
			this.wrapperRef = node;
		}
	}, {
		key: "handleClickOutside",
		value: function handleClickOutside(event) {
			if (this.state.isOpen && this.wrapperRef && !this.wrapperRef.contains(event.target)) {
				this.setState({ isOpen: false });
			}
		}
	}, {
		key: "handleTabOutside",
		value: function handleTabOutside(event) {
			if (this.state.isOpen && this.wrapperRef && !this.wrapperRef.contains(event.target)) {
				this.setState({ isOpen: false });
			}
		}
	}]);

	return ColorPicker;
}(_react.Component);

ColorPicker.propTypes = {
	/** isOpen sets the standard state of the ColorPicker dropdown */
	isOpen: _propTypes2.default.bool,
	transitionTimeout: _propTypes2.default.oneOfType([_propTypes2.default.shape({ enter: _propTypes2.default.number, exit: _propTypes2.default.number }), _propTypes2.default.number])
};
ColorPicker.defaultProps = {
	transitionTimeout: 240,
	onChange: function onChange() {}
};
exports.default = ColorPicker;