"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Filter = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Transition = require("react-transition-group/Transition");

var _Transition2 = _interopRequireDefault(_Transition);

var _Button = require("./../Button");

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Filter = exports.Filter = function (_Component) {
	_inherits(Filter, _Component);

	function Filter(props) {
		_classCallCheck(this, Filter);

		var _this = _possibleConstructorReturn(this, (Filter.__proto__ || Object.getPrototypeOf(Filter)).call(this, props));

		_this.setWrapperRef = function (node) {
			_this.wrapperRef = node;
		};

		_this.handleClickOutside = function (event) {
			if (_this.props.useSvg && _this.state.isOpen && _this.wrapperRef && !_this.wrapperRef.contains(event.target)) {
				_this.setState({ isOpen: false });
			}
		};

		_this.handleTabOutside = function (event) {
			if (_this.props.useSvg && _this.state.isOpen && _this.wrapperRef && !_this.wrapperRef.contains(event.target)) {
				_this.setState({ isOpen: false });
			}
		};

		_this.handleOpen = function (openEvent) {
			if (openEvent.target.id.startsWith(_this.props.id)) {
				_this.setState({ isOpen: !_this.state.isOpen });
			}
		};

		_this.render = function () {
			var _this$props = _this.props,
			    id = _this$props.id,
			    type = _this$props.type;
			var isOpen = _this.state.isOpen;


			return _this.props.useSvg ? _react2.default.createElement(
				_Button2.default,
				{ noStyles: true },
				_react2.default.createElement(
					"div",
					{
						id: id,
						tabIndex: "0",
						className: "cp-contentFilter " + (isOpen ? "is-open" : ""),
						onClick: _this.handleOpen
					},
					_react2.default.createElement(
						"svg",
						{
							id: id + "_svg",
							style: {
								display: "inline-block",
								height: "1rem",
								width: "1rem"
							}
						},
						_react2.default.createElement("use", { xlinkHref: "#iconFilter" })
					),
					_this.renderMenu()
				)
			) : _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(
					_Button2.default,
					{
						size: "small",
						type: type,
						id: id,
						onClick: _this.handleOpen,
						style: { width: "100% !imporant" }
					},
					"Filters"
				),
				isOpen && _this.renderMenu()
			);
		};

		_this.renderMenu = function () {
			var transitionTimeout = _this.props.transitionTimeout;
			var isOpen = _this.state.isOpen;

			var transitionProps = { in: isOpen, timeout: transitionTimeout };

			return _react2.default.createElement(
				_Transition2.default,
				transitionProps,
				function (state) {
					return _react2.default.createElement(
						"div",
						{
							className: _this.props.useSvg ? "cp-DropdownMenu-menu cp-DropdownMenu-menu--contentFilter Dropdown-fade-" + state : "cp-contentSearchPanel--searchFilters",
							ref: _this.setWrapperRef
						},
						_this.props.useSvg && _react2.default.createElement(
							"h3",
							{ className: "cp-DropdownMenu-menuHeading" },
							"Filter"
						),
						_this.props.children,
						_react2.default.createElement(
							"div",
							null,
							_react2.default.createElement(
								_Button2.default,
								{
									onClick: _this.props.clearFilters,
									size: "small",
									style: {
										width: "100%",
										marginTop: "" + (!_this.props.useSvg ? "-2rem" : "")
									}
								},
								"Clear Filters"
							)
						)
					);
				}
			);
		};

		_this.state = {
			dropdownLabel: _this.props.title,
			isOpen: _this.props.startOpened || false
		};
		return _this;
	}

	_createClass(Filter, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			document.addEventListener("mousedown", this.handleClickOutside);
			document.addEventListener("keyup", this.handleTabOutside);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			document.removeEventListener("mousedown", this.handleClickOutside);
			document.removeEventListener("keyup", this.handleTabOutside);
		}
	}]);

	return Filter;
}(_react.Component);

Filter.propTypes = {
	clearFilters: _propTypes2.default.func,
	title: _propTypes2.default.string,
	id: _propTypes2.default.string.isRequired,
	onChange: _propTypes2.default.func,
	transitionTimeout: _propTypes2.default.oneOfType([_propTypes2.default.shape({
		enter: _propTypes2.default.number,
		exit: _propTypes2.default.number
	}), _propTypes2.default.number]),
	type: _propTypes2.default.string,
	startOpened: _propTypes2.default.bool
};
Filter.defaultProps = {
	title: "Filter",
	transitionTimeout: 240,
	onChange: function onChange(e) {},
	type: "primary"
};
exports.default = Filter;