'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.FormField = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _blacklist = require('blacklist');

var _blacklist2 = _interopRequireDefault(_blacklist);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormField = exports.FormField = function (_Component) {
	_inherits(FormField, _Component);

	function FormField() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FormField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormField.__proto__ || Object.getPrototypeOf(FormField)).call.apply(_ref, [this].concat(args))), _this), _this.render = function () {
			// classes
			var componentClass = (0, _classnames2.default)('cp-FormField', {
				'offset-absent-label': _this.props.offsetAbsentLabel
			}, _this.props.size ? 'cp-FormField--' + _this.props.size : '', _this.props.width, _this.props.className);

			var _this$props = _this.props,
			    hasError = _this$props.hasError,
			    errorMessage = _this$props.errorMessage;
			// props

			var props = (0, _blacklist2.default)(_this.props, 'className', 'label', 'offsetAbsentLabel', 'width', 'hasError', 'errorMessage');

			// elements
			var componentLabel = _this.props.label ? _react2.default.createElement(
				'label',
				{ className: 'cp-FormField-label ' + (_this.props.size ? 'cp-FormField-label--' + _this.props.size : ''), htmlFor: _this.props.id || _this.props.htmlFor },
				_this.props.label,
				_this.props.required ? _react2.default.createElement(
					'span',
					{ className: 'cp-Required' },
					'Required'
				) : null
			) : null;

			var formError = hasError ? _react2.default.createElement(
				'div',
				{ className: 'cp-FormField-errorHolder', style: { display: 'block' } },
				_react2.default.createElement(
					'div',
					{ className: 'cp-UIMessage cp-UIMessage--error' },
					_react2.default.createElement(
						'strong',
						{ className: 'cp-UIMessage-label' },
						'Oops'
					),
					_react2.default.createElement(
						'span',
						{ className: 'cp-UIMessage-text' },
						errorMessage
					)
				)
			) : null;

			return _react2.default.createElement(
				'div',
				_extends({ className: componentClass }, props),
				componentLabel,
				_this.props.children,
				formError
			);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return FormField;
}(_react.Component);

FormField.propTypes = {
	className: _propTypes2.default.string,
	errorMessage: _propTypes2.default.string,
	id: _propTypes2.default.string,
	hasError: _propTypes2.default.bool,
	htmlFor: _propTypes2.default.string,
	label: _propTypes2.default.string,
	offsetAbsentLabel: _propTypes2.default.bool,
	required: _propTypes2.default.bool,
	size: _propTypes2.default.oneOf(['minor']),
	width: _propTypes2.default.oneOf(['one-half', 'two-quarters', 'three-sixths', 'one-quarter', 'three-quarters', 'one-third', 'two-sixths', 'two-thirds', 'four-sixths', 'one-fifth', 'two-fifths', 'three-fifths', 'four-fifths', 'one-sixth', 'five-sixths'])
};
exports.default = FormField;