'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.FormNote = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _blacklist = require('blacklist');

var _blacklist2 = _interopRequireDefault(_blacklist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NOTE_TYPES = ['default', 'primary', 'success', 'warning', 'danger'];

var FormNote = exports.FormNote = function (_Component) {
	_inherits(FormNote, _Component);

	function FormNote() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FormNote);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormNote.__proto__ || Object.getPrototypeOf(FormNote)).call.apply(_ref, [this].concat(args))), _this), _this.render = function () {
			// classes
			var componentClass = (0, _classnames2.default)('FormNote', _this.props.type ? 'FormNote--' + _this.props.type : null, _this.props.className);

			// props
			var props = (0, _blacklist2.default)(_this.props, 'className', 'note', 'type');

			// allow users to pass through the note as an attribute or as children
			if (_this.props.note) {
				return _react2.default.createElement('div', _extends({ className: componentClass, dangerouslySetInnerHTML: _this.props.note ? { __html: _this.props.note } : null }, props));
			} else {
				return _react2.default.createElement(
					'div',
					_extends({ className: componentClass }, props),
					_this.props.children
				);
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	return FormNote;
}(_react.Component);

FormNote.propTypes = {
	className: _propTypes2.default.string,
	note: _propTypes2.default.string,
	type: _propTypes2.default.oneOf(NOTE_TYPES)
};
FormNote.defaultProps = {
	type: 'default'
};
exports.default = FormNote;