'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.LiveEditPanelHeader = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Dropdown = require('../Dropdown/Dropdown');

var _Button = require('../Button/Button');

var _LiveEditPanelTabs = require('../LiveEditPanelTabs/LiveEditPanelTabs');

var _LiveEditPanelTab = require('../LiveEditPanelTab/LiveEditPanelTab');

var _reactAnimateHeight = require('react-animate-height');

var _reactAnimateHeight2 = _interopRequireDefault(_reactAnimateHeight);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * The CivicPlus Live Edit Details Panel Header. This may be migrated to the Borealis Project.
 */
var LiveEditPanelHeader = exports.LiveEditPanelHeader = function (_Component) {
	_inherits(LiveEditPanelHeader, _Component);

	function LiveEditPanelHeader(props) {
		_classCallCheck(this, LiveEditPanelHeader);

		var _this = _possibleConstructorReturn(this, (LiveEditPanelHeader.__proto__ || Object.getPrototypeOf(LiveEditPanelHeader)).call(this, props));

		_this.handleOpen = function (openEvent) {
			_this.setState({ isOpen: !_this.state.isOpen });
		};

		_this.render = function () {
			return _react2.default.createElement(
				'div',
				{ className: 'cp-liveEditPanel-detailHeader' },
				_react2.default.createElement(
					_LiveEditPanelTabs.LiveEditPanelTabs,
					null,
					_react2.default.createElement(_LiveEditPanelTab.LiveEditPanelTab, { title: 'Content', icon: 'iconModuleFormCenter' }),
					_react2.default.createElement(_LiveEditPanelTab.LiveEditPanelTab, { title: 'Design', icon: 'iconModuleDesignCenter' }),
					_react2.default.createElement(_LiveEditPanelTab.LiveEditPanelTab, { title: 'Options', icon: 'iconSettings' })
				),
				_react2.default.createElement(
					'h4',
					{ className: 'cp-LiveEditPanel-detailSubHeader cp-LiveEditPanel-detailSubHeader--expandable ' + (_this.state.isOpen ? 'is-open' : ''), onClick: _this.handleOpen },
					'Global',
					_react2.default.createElement(
						'svg',
						{ className: 'cp-liveEditPanel-detailHeader-expandIcon' },
						_react2.default.createElement('use', { xlinkHref: '#iconArrow--down' })
					)
				),
				_react2.default.createElement(
					_reactAnimateHeight2.default,
					{
						duration: 360,
						height: _this.state.isOpen ? 'auto' : '0',
						className: 'cp-liveEditPanel-detailHeaderInner ' + (_this.state.isOpen ? 'is-open' : '')
					},
					_react2.default.createElement(
						'div',
						{ className: 'cp-globalOptionSelect cp-clearfix' },
						_react2.default.createElement(
							'svg',
							{ className: 'cp-globalOptionSelect-glyph cp-globalOptionSelect-Glyph--theme' },
							_react2.default.createElement('use', { xlinkHref: '#iconModuleDesignCenter' })
						),
						_react2.default.createElement(_Dropdown.Dropdown, { className: 'cp-globalOptionSelect-dropdown cp-globalOptionSelect-dropdown--hasActions', size: 'small', options: ["Skin 1", "Skin 2", "Skin 3"], startValue: 'Skin 1', selectedOption: 0 }),
						_react2.default.createElement(
							'div',
							{ className: 'cp-globalOptionSelect-actions cp-clearfix' },
							_react2.default.createElement(
								_Button.Button,
								{ title: 'New Skin', className: 'cp-globalOptionSelect-action cp-globalOptionSelect-action--new', noStyles: true },
								_react2.default.createElement(
									'svg',
									{ className: 'cp-globalOptionSelect-glyph' },
									_react2.default.createElement('use', { xlinkHref: '#iconAdd' })
								)
							),
							_react2.default.createElement(
								_Button.Button,
								{ title: 'Copy Skin', className: 'cp-globalOptionSelect-action cp-globalOptionSelect-action--copy', noStyles: true },
								_react2.default.createElement(
									'svg',
									{ className: 'cp-globalOptionSelect-glyph' },
									_react2.default.createElement('use', { xlinkHref: '#iconModules' })
								)
							),
							_react2.default.createElement(
								_Button.Button,
								{ title: 'Delete Skin', className: 'cp-globalOptionSelect-action cp-globalOptionSelect-action--delete', noStyles: true },
								_react2.default.createElement(
									'svg',
									{ className: 'cp-globalOptionSelect-glyph' },
									_react2.default.createElement('use', { xlinkHref: '#iconDelete' })
								)
							)
						)
					),
					_react2.default.createElement(
						'div',
						{ className: 'cp-globalOptionSelect cp-clearfix' },
						_react2.default.createElement(
							'svg',
							{ className: 'cp-globalOptionSelect-glyph cp-globalOptionSelect-Glyph--optionSet' },
							_react2.default.createElement('use', { xlinkHref: '#iconSettings' })
						),
						_react2.default.createElement(_Dropdown.Dropdown, { className: 'cp-globalOptionSelect-dropdown', size: 'small', options: ["Option Set 1", "Option Set 2", "Option Set 3"], startValue: 'Option Set 1', selectedOption: 0 })
					),
					_react2.default.createElement(
						_Button.Button,
						{ noStyles: true, className: 'cp-liveEditPanel-detailHeader-collapse', onClick: _this.handleOpen },
						_react2.default.createElement(
							'svg',
							{ className: 'cp-liveEditPanel-detailHeader-collapseIcon' },
							_react2.default.createElement('use', { xlinkHref: '#iconArrow--up' })
						)
					)
				)
			);
		};

		_this.state = {
			isOpen: _this.props.open
		};
		return _this;
	}

	return LiveEditPanelHeader;
}(_react.Component);

LiveEditPanelHeader.propTypes = {
	/** isOpen sets the standard state of the accordion */
	isOpen: _propTypes2.default.bool
};
LiveEditPanelHeader.defaultProps = {
	isOpen: false
};
exports.default = LiveEditPanelHeader;